import {ChartViewInterface} from "@/Services/ChartView/ChartViewInterface";
import {ChartViewAbstract} from "@/Services/ChartView/ChartViewAbstract";
import {ZmartChartsApex} from "@/Services/Chats/ZmartChartsApex";
import {ChartViewService} from "@/Services/ChartViewService";

export class BarLine extends ChartViewAbstract implements ChartViewInterface {
    public legendPositionDropdownIsVisible: Boolean = true;

    public getWidget(dashboard: any, widget: any) {
        const height = widget[0].style;
        if (dashboard.label !== '' || dashboard.label !== null) {
            widget[0].options.title.text = dashboard.label;
        }
        widget[0].style = "background: " + dashboard.color + "; " + height;
        return widget;
    }

    public getCharts(charts: any) {
        return charts;
    }

    public setMask(charts: any) {
        charts[0].options.yAxis.forEach((yAxis: any, index: any) => {
            if (yAxis.axisLabel) {
                const maskFunction = ChartViewService.getMaskFunction(yAxis.maskFunction);
                yAxis.axisLabel.formatter = maskFunction;
                charts[0].options.series.forEach((serie: any) => {
                    if (serie.label && serie.yAxisIndex === index) {
                        serie.label.formatter = this.setMaskSerie.bind(this, maskFunction);
                        serie.tooltip = {
                            valueFormatter: maskFunction
                        };
                    }
                });
                charts[0].options.tooltip.valueFormatter = maskFunction;
            }
        });
    }

    public setMaskSerie(maskFunction: any, param: any) {
        return maskFunction(param.value);
    }

    public setDrill(charts: any, zmartCharts: ZmartChartsApex) {
        this.zmartCharts = zmartCharts;
        this.setMask(charts);

        charts[0].events = {
            "mounted": this.getZmartCharts().mounted.bind(this.getZmartCharts()),
            "chartClick": this.getZmartCharts().drillEChartsBar.bind(this.getZmartCharts(), charts[0].widget),
        };

        return charts;
    }

    public getSaveViewParams(formExtra: any, values: any, cleanValues: any) {
        if (cleanValues.chartXAxisField_GERAL) {
            cleanValues.chartXAxisField = cleanValues.chartXAxisField_GERAL;
        }
        cleanValues.serieColors = cleanValues.originSerieColors;
        return cleanValues;
    }

    public getEditData(viewData: any) {
        if (Array.isArray(viewData.serieColors)) {
            viewData.originSerieColors = viewData.serieColors;
        }
        if (Array.isArray(viewData.serieColorsBar)) {
            viewData.originSerieColorsBar = viewData.serieColorsBar;
        }
        if (Array.isArray(viewData.serieColorsLine)) {
            viewData.originSerieColorsLine = viewData.serieColorsLine;
        }
        if (viewData.chartXAxisField) {
            viewData.chartXAxisField_GERAL = viewData.chartXAxisField;
        }
        return viewData;
    }
}
